SystemOrganization addCategory: #'XML-Parser-GTExtensions'!

!XMLNodeWithElements class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode nodes! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/21/2015 23:36'!
asHighlightedText
	| writer |

	writer := XMLHighlightingWriter new.
	self writeXMLOn: writer.
	^ writer asHighlightedText.! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/21/2015 23:35'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 40>

	"removed unfinished source panel editing support for now"
	composite text 
		title: 'Source';
		format: [ self asHighlightedText ]! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/22/2015 01:18'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite tree
		title: 'Tree';
		display: [ {self} ];
		children: #elements;
		format: #treeNodeLabelText;
		when: [ self hasElements ];
		rootsExpanded! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 3/6/2015 14:40'!
gtName
	^ ''! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 7/12/2015 15:35'!
gtSpotterAllElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'All elements';
		allCandidates: [ self allElements ];
		itemName: [ :element | element gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 7/12/2015 15:35'!
gtSpotterDirectElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'Direct elements';
		allCandidates: [ self elements ];
		itemName: [ :element | element gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 7/12/2015 15:14'!
spotterPreviewSourceIn: aComposite
	<spotterPreview: 10>
	
	aComposite text
		title: 'Source';
		display: [ :anElement | self prettyPrinted ];
		entity: self! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/22/2015 01:18'!
treeNodeLabelText
	self subclassResponsibility! !

XMLWriter subclass: #XMLHighlightingWriter
	instanceVariableNames: 'highlights'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions'!

!XMLHighlightingWriter commentStamp: 'monty 9/21/2015 06:39' prior: 0!
This class is an XMLWriter that can make highlighted text output with XMLHighlightingPrettyPrintingWriterFormatter.!

!XMLHighlightingWriter class methodsFor: 'instance creation' stamp: 'monty 9/21/2015 06:41'!
on: aStream
	^ (super on: aStream) formatter: XMLHighlightingPrettyPrintingWriterFormatter new! !

!XMLHighlightingWriter methodsFor: 'private ' stamp: 'monty 9/21/2015 06:45'!
addHighlight: aHighlight
	^ highlights addLast: aHighlight! !

!XMLHighlightingWriter methodsFor: 'converting' stamp: 'monty 9/21/2015 06:45'!
asHighlightedText
	| text |

	text := self asString asText.
	highlights do: [:each | each applyToText: text].
	^ text.! !

!XMLHighlightingWriter methodsFor: 'initialization' stamp: 'monty 9/20/2015 01:11'!
initialize
	super initialize.

	highlights := OrderedCollection new.! !

!XMLHighlightingWriter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:52'!
position
	^ stream position! !

XMLPrettyPrintingWriterFormatter subclass: #XMLHighlightingPrettyPrintingWriterFormatter
	instanceVariableNames: 'xmlDeclarationColor doctypeDeclarationColor declarationColor piColor entityReferenceColor commentColor tagColor cdataColor quotedStringValueColor xmlDeclarationHighlight doctypeDeclarationHighlight declarationHighlight piHighlight entityReferenceHighlight commentHighlight tagHighlight cdataHighlight quotedStringValueHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions'!

XMLHighlightingPrettyPrintingWriterFormatter class
	instanceVariableNames: 'defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLHighlightingPrettyPrintingWriterFormatter commentStamp: 'monty 9/21/2015 06:43' prior: 0!
This formatter adds highlights to XMLHighlightingWriter output.!

XMLHighlightingPrettyPrintingWriterFormatter class
	instanceVariableNames: 'defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:26'!
defaultCDataColor
	^ defaultCDataColor
		ifNil: [defaultCDataColor := self textColorForShoutProperty: #primitive]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:26'!
defaultCDataColor: aTextColor
	defaultCDataColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:26'!
defaultCommentColor
	^ defaultCommentColor
		ifNil: [defaultCommentColor :=  self textColorForShoutProperty: #comment]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultCommentColor: aTextColor
	defaultCommentColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultEntityReferenceColor
	^ defaultEntityReferenceColor
		ifNil: [defaultEntityReferenceColor := self textColorForShoutProperty: #character]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultEntityReferenceColor: aTextColor
	defaultEntityReferenceColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultPrimaryMarkupColor
	^ defaultPrimaryMarkupColor
		ifNil: [defaultPrimaryMarkupColor := self textColorForShoutProperty: #argument]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultPrimaryMarkupColor: aTextColor
	defaultPrimaryMarkupColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultQuotedStringValueColor
	^ defaultQuotedStringValueColor
		ifNil: [defaultQuotedStringValueColor := self textColorForShoutProperty: #string]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultQuotedStringValueColor: aTextColor
	defaultQuotedStringValueColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultSecondaryMarkupColor
	^ defaultSecondaryMarkupColor
		ifNil: [defaultSecondaryMarkupColor := self textColorForShoutProperty: #self]! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'accessing' stamp: 'monty 9/22/2015 01:27'!
defaultSecondaryMarkupColor: aTextColor
	defaultSecondaryMarkupColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'class initialization' stamp: 'monty 9/21/2015 22:45'!
initialize
	"self initialize"

	self
		defaultPrimaryMarkupColor: nil;
		defaultSecondaryMarkupColor: nil;
		defaultQuotedStringValueColor: nil;
		defaultEntityReferenceColor: nil;
		defaultCommentColor: nil;
		defaultCDataColor: nil! !

XMLHighlightingPrettyPrintingWriterFormatter initialize!

!XMLHighlightingPrettyPrintingWriterFormatter class methodsFor: 'private' stamp: 'monty 9/22/2015 00:07'!
textColorForShoutProperty: aShoutProperty
	^ TextColor color:
		(((SHTextStylerST80 new attributesFor: aShoutProperty)
			detect: [:each | each respondsTo: #color]
			ifNone: [^ nil]) color)! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 02:58'!
cdataColor
	^ cdataColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 02:58'!
cdataColor: aTextColor
	cdataColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
commentColor
	^ commentColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:17'!
commentColor: aTextColor
	commentColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
declarationColor
	^ declarationColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:17'!
declarationColor: aTextColor
	declarationColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
doctypeDeclarationColor
	^ doctypeDeclarationColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:19'!
doctypeDeclarationColor: aTextColor
	doctypeDeclarationColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private ' stamp: 'monty 9/20/2015 01:55'!
endHighlight: aHighlight
	aHighlight
		ifNotNil: [aHighlight end: self writer position]! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
entityReferenceColor
	^ entityReferenceColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:19'!
entityReferenceColor: aTextColor
	entityReferenceColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 02:59'!
formatAfterCData: aCDataWriter
	self endHighlight: cdataHighlight.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 21:46'!
formatAfterCharacterEscape: aCharacterEscape
	self endHighlight: entityReferenceHighlight.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:31'!
formatAfterComment: aCommentWriter
	self endHighlight: commentHighlight.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:31'!
formatAfterDeclaration: aDeclarationWriter
	self endHighlight: declarationHighlight.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:31'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	self endHighlight: doctypeDeclarationHighlight.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:33'!
formatAfterEndTag: aTagWriter
	self endHighlight: tagHighlight.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:33'!
formatAfterEntityReference: anEntityReferenceWriter
	self endHighlight: entityReferenceHighlight.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:28'!
formatAfterPI: aPIWriter
	self endHighlight: piHighlight.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:34'!
formatAfterQuotedStringValue: aString
	self endHighlight: quotedStringValueHighlight.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:34'!
formatAfterStartTag: aTagWriter
	self endHighlight: tagHighlight.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:34'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	self endHighlight: xmlDeclarationHighlight.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 02:58'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	cdataHighlight := self newHighlightColored: self cdataColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 21:46'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	entityReferenceHighlight := self newHighlightColored: self entityReferenceColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:35'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	commentHighlight := self newHighlightColored: self commentColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:35'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	declarationHighlight := self newHighlightColored: self declarationColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:37'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	doctypeDeclarationHighlight := self newHighlightColored: self doctypeDeclarationColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:36'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	self startNewTagHighlight.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:37'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	entityReferenceHighlight := self newHighlightColored: self entityReferenceColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:27'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	piHighlight := self newHighlightColored: self piColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:38'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	quotedStringValueHighlight := self newHighlightColored: self quotedStringValueColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:36'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	self startNewTagHighlight.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 9/20/2015 01:38'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	xmlDeclarationHighlight := self newHighlightColored: self xmlDeclarationColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'initialization' stamp: 'monty 9/21/2015 22:51'!
initialize
	super initialize.

	xmlDeclarationColor := self class defaultSecondaryMarkupColor.
	doctypeDeclarationColor := self class defaultSecondaryMarkupColor.
	piColor := self class defaultSecondaryMarkupColor.

	declarationColor := self class defaultPrimaryMarkupColor.
	tagColor := self class defaultPrimaryMarkupColor.

	quotedStringValueColor := self class defaultQuotedStringValueColor.
	entityReferenceColor := self class defaultEntityReferenceColor.
	commentColor := self class defaultCommentColor.
	cdataColor := self class defaultCDataColor.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private ' stamp: 'monty 9/20/2015 01:57'!
newHighlightColored: aTextColor
	^ aTextColor
		ifNotNil: [
			self writer addHighlight: 
				(XMLHighlight new
					color: aTextColor;
					start: self writer position + 1)]! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
piColor
	^ piColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
piColor: aTextColor
	piColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
quotedStringValueColor
	^ quotedStringValueColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
quotedStringValueColor: aTextColor
	quotedStringValueColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private ' stamp: 'monty 9/20/2015 01:36'!
startNewTagHighlight
	tagHighlight := self newHighlightColored: self tagColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
tagColor
	^ tagColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
tagColor: aTextColor
	tagColor := aTextColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:16'!
xmlDeclarationColor
	^ xmlDeclarationColor! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:20'!
xmlDeclarationColor: aTextColor
	xmlDeclarationColor := aTextColor! !

!XMLDocument class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDOMParser parse: '<document><a></a><b></b></document>'! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/22/2015 01:18'!
treeNodeLabelText
	| writer |

	writer := XMLHighlightingWriter new.
	self writeXMLDeclarationOn: writer.
	^ writer asHighlightedText.! !

!XMLElement class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode firstElement! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 16:48'!
formForImageEntity: imageEntity
  | imageType parserClassName parserClass parser |
  imageType := imageEntity contentType sub.
  parserClassName := imageType asUppercase, #ReadWriter.
  parserClass := Smalltalk globals at: parserClassName asSymbol.
  parser := parserClass on: imageEntity readStream.
    ^ parser nextImage! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 20:14'!
gtInspectorImageIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 40>
	|client url|
	
	(aGTInspector panes size > 1) 
		ifFalse: [ ^ self ].	
	
	client := (aGTInspector panes reversed collect: [ :each | (each port: #entity) value ])
		detect: [ :each | 
			(each isKindOf: ZnClient)
				and: [each request notNil]]
		ifNone: [ ^ self ].
	url := client request absoluteUrl.
	
	^ composite morph 
		title: 'Image';
		display: [ 
			self formForImageEntity:
				(ZnClient new 
      				beOneShot;
      				get: url/ (self attributeNodes attributeValueAt: 'src');
      				entity)];
		when: [ self name = 'img' and: [(self attributeNodes attributeValueAt: 'src') notNil]]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 3/6/2015 14:40'!
gtName
	^ self localName! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/22/2015 01:18'!
treeNodeLabelText
	| writer |

	writer := XMLHighlightingWriter new.
	(self hasChildren
		ifTrue: [writer startTag]
		ifFalse: [writer tag])
		name: self name;
		setAttributes: attributes;
		write.
	^ writer asHighlightedText.! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 7/12/2015 15:30'!
gtSpotterXMLDocumentFor: aStep
	<spotterOrder: 40>
	self extension = 'xml' ifFalse: [ ^ self ].
	aStep listProcessor
		title: 'XML document';
		allCandidates: [ (XMLDOMParser parse: self) allElements ];
		itemName: [ :element | element gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!ZnStringEntity methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 5/8/2015 23:03'!
gtInspectorXmlIn: composite
	<gtInspectorPresentationOrder: 40>
	| xml |
	xml := [XMLDOMParser parse: self string]
		on: XMLParserException
		do: [ ^ self ].
	(xml gtInspectorTreeIn: composite)
		title: 'XML'! !

Object subclass: #XMLHighlight
	instanceVariableNames: 'color start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions'!

!XMLHighlight commentStamp: 'monty 9/21/2015 04:24' prior: 0!
This class stores a highlight TextColor and 1-based start/end highlight positions.!

!XMLHighlight methodsFor: 'highlighting' stamp: 'monty 9/20/2015 01:27'!
applyToText: aText
	aText
		addAttribute: self color
		from: self start
		to: self end! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
color
	^ color! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
color: aTextColor
	color := aTextColor! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
end
	^ end! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
end: anEndPosition
	end := anEndPosition! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
start
	^ start! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
start: aStartPosition
	start := aStartPosition! !

XMLHighlightingPrettyPrintingWriterFormatter initialize!
